/* ACID WARP (c)Copyright 1992, 1993 by Noah Spurrier
 * All Rights reserved. Private Proprietary Source Code by Noah Spurrier
 * Ported to Linux by Steven Wills
 */
#include <malloc.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <gtk/gtk.h>
#include <unistd.h>

#include "warp_text.c"
#include "handy.h"
#include "acidwarp.h"
#include "lut.h"
#include "bit_map.h"
#include "palinit.h"
#include "rolnfade.h"

#define NUM_IMAGE_FUNCTIONS 40
#define NOAHS_FACE   0

/* there are WAY too many global things here... */
extern int RedRollDirection, GrnRollDirection, BluRollDirection;
extern UINT FadeCompleteFlag;

int ROTATION_DELAY = 30000;

GtkWindow *window;
GtkWidget *drawing_area, *vbox;
GtkWidget *menu_bar, *options_item, *lock_item, *options_menu, 	*skip_item, *shorter_item, 	*longer_item, *newpal_item, *quit_item ; // these don't all have to be global

int logo_time = 30, image_time = 20;
int XMax = 0, YMax = 0;
UCHAR *buf_graf = 0;
int GO = TRUE;
int SKIP = FALSE;
int NP = FALSE; /* flag indicates new palette */
int LOCK = FALSE; /* flag indicates don't change to next image */
int INTRO = TRUE;
UCHAR MainPalArray [256 * 3];
UCHAR TargetPalArray [256 * 3];



typedef struct {
	time_t ltime, mtime;
 int imageFuncList[NUM_IMAGE_FUNCTIONS], userOptionImageFuncNum;
 int paletteTypeNum, userPaletteTypeNumOptionFlag;
 int imageFuncListIndex, fade_dir;
} looper_data;

gint looper(looper_data *data);


int main (int argc, char *argv[])
{
	/*
  int imageFuncList[NUM_IMAGE_FUNCTIONS], userOptionImageFuncNum;
  int paletteTypeNum = 0, userPaletteTypeNumOptionFlag = FALSE;
  int argNum, imageFuncListIndex=0, fade_dir = TRUE;
  time_t ltime, mtime;
	*/

	looper_data data;

	data.paletteTypeNum = 0;
	data.userPaletteTypeNumOptionFlag = FALSE;
	data.imageFuncListIndex=0;
	data.fade_dir = TRUE;
	
   RANDOMIZE();
  
  /* Default options */
	 data.userPaletteTypeNumOptionFlag = 0;       /* User Palette option is OFF */
	 data.userOptionImageFuncNum = -1; /* No particular functions goes first. */
  
 
  gtk_init (&argc, &argv); // conflict with acidwarp commandline?

  
	/*  printf ("\nPlease wait...\n"
			"\n\n*** Press Control-C to exit the program at any time. ***\n"); */
  printf ("\n\n%s\n", VERSION);
  
  graphicsinit();


  initPalArray(MainPalArray, RGBW_LIGHTNING_PAL);
  initPalArray(TargetPalArray, RGBW_LIGHTNING_PAL);


    /* show the logo for a while */
		XMax = drawing_area->allocation.width;
	YMax = drawing_area->allocation.height;

    writeBitmapImageToArray(buf_graf, NOAHS_FACE, XMax, YMax);
		FadeCompleteFlag = FALSE;

		
		data.ltime=time(NULL);
		data.mtime=	data.ltime + logo_time;


g_timeout_add (20,
                   (gpointer) *looper,
									  &data);
gtk_main ();
 return 0; 
}


gint looper(looper_data *data)
{

	// !!
 GdkRectangle update_rect;
 int resized;

 resized = (!((XMax == drawing_area->allocation.width)  &&		(YMax == drawing_area->allocation.height)));

 if(NP) {
	 newpal();
	 NP = FALSE;
 }

 if(!((	data->mtime<	 time(NULL)) ) &&		(! resized) && (!(SKIP)))
	 {
	
		 rolNFadeMainPalAryToTargNLodDAC(MainPalArray,TargetPalArray);

		 update_rect.x = 0; 
		 update_rect.y = 0;
		 update_rect.width = drawing_area->allocation.width;  
		 update_rect.height =  drawing_area->allocation.height;
		 gtk_widget_draw(drawing_area, &update_rect);

	 }
 else
	 {
		 data->ltime = time(NULL);
		 data->mtime = data->ltime + image_time;
		 
		 /* move to the next image */
		 if ((!(LOCK) && (!(resized))) || INTRO  || SKIP)
			 {
				 makeShuffledList(data->imageFuncList, NUM_IMAGE_FUNCTIONS);
				 
				 if (++(data->imageFuncListIndex) >= NUM_IMAGE_FUNCTIONS)
					 {
						 data->imageFuncListIndex = 0;
						 makeShuffledList(data->imageFuncList, NUM_IMAGE_FUNCTIONS);
					 }
			 }
		 
		 /* install a new image */
		 XMax = drawing_area->allocation.width;
		 YMax = drawing_area->allocation.height;
		 
		 free(buf_graf);
		 buf_graf = malloc((XMax+1)*(YMax+1)*2); 
		 
		 generate_image(
										(data->userOptionImageFuncNum < 0) ? 
										data->imageFuncList[data->imageFuncListIndex] : 
										data->userOptionImageFuncNum, 
										buf_graf, XMax/2, YMax/2, XMax, YMax, 255);
					 
		 /* create new palette */
		 if  ((!(LOCK) && (!(resized))) || INTRO || SKIP)
			 {
				 data->paletteTypeNum = RANDOM(NUM_PALETTE_TYPES +1);
				 initPalArray(TargetPalArray, data->paletteTypeNum);
			 
				 // set up fading
				 FadeCompleteFlag=!FadeCompleteFlag;
				 rollMainPalArrayAndLoadDACRegs(MainPalArray);
			 }
	 SKIP = FALSE;
	 INTRO = FALSE;
	 }

	return TRUE;

}


	void shutdown_func()
		{
  /* exit */


  printStrArray(Command_summary_string);
  printf("%s\n", VERSION);
}

/* ------------------------END MAIN----------------------------------------- */


void newpal()
{
  int paletteTypeNum;
  
  paletteTypeNum = RANDOM(NUM_PALETTE_TYPES +1);
  initPalArray(MainPalArray, paletteTypeNum);
}



gboolean
expose_event_callback (GtkWidget *widget, GdkEventExpose *event, gpointer data)
{

	// try gdk_draw_indexed_image too
	int x,y;
	GdkGC *wind_gc;
	int col_index;
 	GdkVisual *draw_visual;
	GdkImage *draw_image;

	draw_visual = gdk_rgb_get_visual();
	draw_image = gdk_image_new(GDK_IMAGE_FASTEST, draw_visual, XMax, YMax);
	guint32 pixel;

	for (x = 0; x < XMax; ++x)
		for (y = 0; y < YMax; ++y)			{
			// optimizing this code would speed up things a LOT.
			col_index = buf_graf[(XMax * y) + x];
			pixel = (MainPalArray[col_index*3]<< 16) + ( MainPalArray[(col_index*3)+1]<< 8) + ( MainPalArray[(col_index*3)+2]);
			gdk_image_put_pixel(draw_image, x,y, pixel);

			}

	wind_gc = gdk_gc_new(widget->window); 

	gdk_draw_image(widget->window, wind_gc, draw_image, 0,0,0,0, -1,-1);
	gdk_gc_destroy(wind_gc);

	// try GtkImage http://developer.gnome.org/doc/API/gdk/gdk-images.html#GDKIMAGE

	gdk_image_destroy(draw_image);
  return TRUE;
}

static void menuitem_response (gchar *);

void graphicsinit()
{
  window =(GtkWindow *) gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title (GTK_WINDOW (window), "Acid Warp");
	gtk_container_set_border_width (GTK_CONTAINER (window), 10);

	vbox = gtk_vbox_new (FALSE, 0);
	gtk_container_add (GTK_CONTAINER (window), vbox);
	gtk_widget_show (vbox);

  gtk_signal_connect (GTK_OBJECT (window), "destroy",
                      GTK_SIGNAL_FUNC (gtk_exit), NULL);

	drawing_area = gtk_drawing_area_new ();
  g_signal_connect (G_OBJECT (drawing_area), "expose_event",  
	G_CALLBACK (expose_event_callback), NULL); 

	/* setup the menu bar */
	menu_bar = gtk_menu_bar_new ();
	options_menu = gtk_menu_new ();
	gtk_widget_show(options_menu);

 //	gtk_container_add (GTK_CONTAINER (window), menu_bar);
	gtk_widget_show (menu_bar);
	options_item = gtk_menu_item_new_with_label ("Options");
	gtk_widget_show (options_item);

	// now add each item
	lock_item = gtk_check_menu_item_new_with_label ("Lock");
	gtk_widget_show (lock_item);
	gtk_menu_shell_append (GTK_MENU_SHELL (options_menu), lock_item);
 g_signal_connect_swapped (G_OBJECT (lock_item), "activate",
		                      G_CALLBACK (menuitem_response), 
                                      (gpointer) g_strdup ("lock"));


	skip_item = gtk_menu_item_new_with_label ("Skip To Next");
	gtk_widget_show (skip_item);
	gtk_menu_shell_append (GTK_MENU_SHELL (options_menu), skip_item);
	g_signal_connect_swapped (G_OBJECT (skip_item), "activate",
		                      G_CALLBACK (menuitem_response), 
                                      (gpointer) g_strdup ("skip"));

	newpal_item = gtk_menu_item_new_with_label ("New Palette");
	gtk_widget_show (newpal_item);
	gtk_menu_shell_append (GTK_MENU_SHELL (options_menu), newpal_item);
	g_signal_connect_swapped (G_OBJECT (newpal_item), "activate",
		                      G_CALLBACK (menuitem_response), 
                                      (gpointer) g_strdup ("newpal"));


	shorter_item = gtk_menu_item_new_with_label ("Shorter Rotation");
	gtk_widget_show (shorter_item);
	gtk_menu_shell_append (GTK_MENU_SHELL (options_menu), shorter_item);
	g_signal_connect_swapped (G_OBJECT (shorter_item), "activate",
		                      G_CALLBACK (menuitem_response), 
                                      (gpointer) g_strdup ("shorter"));

	longer_item = gtk_menu_item_new_with_label ("Longer Rotation");
	gtk_widget_show (longer_item);
	gtk_menu_shell_append (GTK_MENU_SHELL (options_menu),  longer_item);
	g_signal_connect_swapped (G_OBJECT (longer_item), "activate",
		                      G_CALLBACK (menuitem_response), 
                                      (gpointer) g_strdup ("longer"));

	quit_item = gtk_menu_item_new_with_label ("Quit");
	gtk_widget_show (quit_item);
	gtk_menu_shell_append (GTK_MENU_SHELL (options_menu),  quit_item);
	g_signal_connect_swapped (G_OBJECT (quit_item), "activate",
		                      G_CALLBACK (menuitem_response), 
                                      (gpointer) g_strdup ("quit"));

	gtk_menu_bar_append (GTK_MENU_BAR (menu_bar), options_item);
	gtk_menu_item_set_submenu (GTK_MENU_ITEM (options_item), options_menu);
			
	// now show menu and drawing area inside of vbox
	gtk_box_pack_start (GTK_BOX (vbox), menu_bar, FALSE, FALSE, 2);
	
	// a good default.  let them resize if they want
	XMax = 319;
	YMax = 199; // be sure to change this elsewhere if you change it here
	buf_graf = malloc((XMax+1)*(YMax+1)*2);
	memset(buf_graf, 0x00, (size_t)(320*200));

	//	printf("%p pointer\n", buf_graf);
	gtk_window_resize(window,XMax+1, YMax+1);
	gtk_widget_set_size_request (drawing_area,XMax+1, YMax+1);

 gtk_box_pack_end (GTK_BOX (vbox), GTK_WIDGET (drawing_area), TRUE, TRUE, 2);
	gtk_widget_show ((GtkWidget *) drawing_area);
  gtk_widget_show ((GtkWidget *) window);

}

static void menuitem_response( gchar *string ) // there's probably a better signalling method.  i'm not sure
{
	if (strcmp(string, "lock") == 0)
		{
			LOCK = ! LOCK;
			//			printf("lock %i\n", LOCK);
		}
	else if (strcmp(string, "skip") == 0)
		{
			SKIP = TRUE;
		}
	else if (strcmp(string, "newpal") == 0)
		{
			NP = TRUE;
		}
	else if(strcmp(string, "shorter") == 0)
		{
			ROTATION_DELAY = ROTATION_DELAY - 5000;
      if (ROTATION_DELAY < 0)
				ROTATION_DELAY = 0;
		}
	else if		(strcmp(string, "longer") == 0)
		{
     ROTATION_DELAY = ROTATION_DELAY + 5000;
		}
	else if		(strcmp(string, "quit") == 0)
		{
			gtk_exit(0);
		}

}



void printStrArray(char *strArray[])
{
  /* Prints an array of strings.  The array is terminated with a null string.     */
  char **strPtr;
  
  for (strPtr = strArray; **strPtr; ++strPtr)
    printf ("%s", *strPtr);
}

void makeShuffledList(int *list, int listSize)
{
  int entryNum, r;
  
  for (entryNum = 0; entryNum < listSize; ++entryNum)
    list[entryNum] = -1;
  
  for (entryNum = 0; entryNum < listSize; ++entryNum)
    {
      do
	r = RANDOM(listSize);
      while (list[r] != -1);
      
      list[r] = entryNum;
    }
}

int generate_image(int imageFuncNum, UCHAR *buf_graf, int xcenter, int ycenter, int xmax, int ymax, int colormax)
{
	
	// just reallocate, we may have been resized
	//	printf("GENERATE %i %i\n", xmax, imageFuncNum);
  /* WARNING!!! Major change from long to int.*/
  /* ### Changed back to long. Gives lots of warnings. Will fix soon. */
  
  long /* int */ x, y, dx, dy, dist, angle;
  long color;
  
  /* Some general purpose random angles and offsets. Not all functions use them. */
  long a1, a2, a3, a4, x1,x2,x3,x4,y1,y2,y3,y4;
  
  x1 = RANDOM(40)-20;  x2 = RANDOM(40)-20;  x3 = RANDOM(40)-20;  x4 = RANDOM(40)-20;
  y1 = RANDOM(40)-20;  y2 = RANDOM(40)-20;  y3 = RANDOM(40)-20;  y4 = RANDOM(40)-20;
  
  a1 = RANDOM(ANGLE_UNIT);  a2 = RANDOM(ANGLE_UNIT);  a3 = RANDOM(ANGLE_UNIT);  a4 = RANDOM(ANGLE_UNIT);

	// we should move below to a loop which can be called to produce this in steps
  for (y = 0; y < ymax; ++y)
    {
      
      for (x = 0; x < xmax; ++x)
	{
	  dx = x - xcenter;
	  dy = y - ycenter;
	  
	  dist  = lut_dist (dx, dy);
	  angle = lut_angle (dx, dy);
	  
	  /* select function. Could be made a separate function, but since 
             this function is evaluated over a large iteration of values I am 
             afraid that it might slow things down even more to have a 
             separate function.	*/
	  
	  switch (imageFuncNum)
	    {
	      /* case -1:	Eight Arm Star -- produces weird discontinuity
                color = dist+ lut_sin(angle * (200 - dist)) / 32;
						break;
						*/
	    case 0: /* Rays plus 2D Waves */
	      color = angle + lut_sin (dist * 10) / 64 +
		lut_cos (x * ANGLE_UNIT / xmax * 2) / 32 +
		lut_cos (y * ANGLE_UNIT / ymax * 2) / 32;
	      break;
	      
	    case 1:	/* Rays plus 2D Waves */
	      color = angle + lut_sin (dist * 10) / 16 +
		lut_cos (x * ANGLE_UNIT / xmax * 2) / 8 +
		lut_cos (y * ANGLE_UNIT / ymax * 2) / 8;
	      break;
	      
	    case 2:
	      color = lut_sin (lut_dist(dx + x1, dy + y1) *  4) / 32 +
		lut_sin (lut_dist(dx + x2, dy + y2) *  8) / 32 +
		lut_sin (lut_dist(dx + x3, dy + y3) * 16) / 32 +
		lut_sin (lut_dist(dx + x4, dy + y4) * 32) / 32;
	      break;
	      
	    case 3:	/* Peacock */
	      color = angle + lut_sin (lut_dist(dx + 20, dy) * 10) / 32 +
		angle + lut_sin (lut_dist(dx - 20, dy) * 10) / 32;
	      break;
	      
	    case 4:
	      color = lut_sin (dist) / 16;
	      break;
	      
	    case 5:	/* 2D Wave + Spiral */
	      color = lut_cos (x * ANGLE_UNIT / xmax) / 8 +
		lut_cos (y * ANGLE_UNIT / ymax) / 8 +
		angle + lut_sin(dist) / 32;
	      break;
	      
	    case 6:	/* Peacock, three centers */
	      color = lut_sin (lut_dist(dx,      dy - 20) * 4) / 32+
		lut_sin (lut_dist(dx + 20, dy + 20) * 4) / 32+
		lut_sin (lut_dist(dx - 20, dy + 20) * 4) / 32;
	      break;
	      
	    case 7:	/* Peacock, three centers */
	      color = angle +
		lut_sin (lut_dist(dx,      dy - 20) * 8) / 32+
		lut_sin (lut_dist(dx + 20, dy + 20) * 8) / 32+
		lut_sin (lut_dist(dx - 20, dy + 20) * 8) / 32;
	      break;
	      
	    case 8:	/* Peacock, three centers */
	      color = lut_sin (lut_dist(dx,      dy - 20) * 12) / 32+
		lut_sin (lut_dist(dx + 20, dy + 20) * 12) / 32+
		lut_sin (lut_dist(dx - 20, dy + 20) * 12) / 32;
	      break;
	      
	    case 9:	/* Five Arm Star */
	      color = dist + lut_sin (5 * angle) / 64;
	      break;
	      
	    case 10:	/* 2D Wave */
	      color = lut_cos (x * ANGLE_UNIT / xmax * 2) / 4 +
		lut_cos (y * ANGLE_UNIT / ymax * 2) / 4;
	      break;
	      
	    case 11:	/* 2D Wave */
	      color = lut_cos (x * ANGLE_UNIT / xmax) / 8 +
		lut_cos (y * ANGLE_UNIT / ymax) / 8;
	      break;
	      
	    case 12:	/* Simple Concentric Rings */
	      color = dist;
	      break;
	      
	    case 13:	/* Simple Rays */
	      color = angle;
	      break;
	      
	    case 14:	/* Toothed Spiral Sharp */
	      color = angle + lut_sin(dist * 8)/32;
	      break;
	      
	    case 15:	/* Rings with sine */
	      color = lut_sin(dist * 4)/32;
	      break;
	      
	    case 16:	/* Rings with sine with sliding inner Rings */
	      color = dist+ lut_sin(dist * 4) / 32;
	      break;
	      
	    case 17:
	      color = lut_sin(lut_cos(2 * x * ANGLE_UNIT / xmax)) / (20 + dist)
                + lut_sin(lut_cos(2 * y * ANGLE_UNIT / ymax)) / (20 + dist);
	      break;
	      
	    case 18:	/* 2D Wave */
	      color = lut_cos(7 * x * ANGLE_UNIT / xmax)/(20 + dist) +
		lut_cos(7 * y * ANGLE_UNIT / ymax)/(20 + dist);
	      break;
	      
	    case 19:	/* 2D Wave */
	      color = lut_cos(17 * x * ANGLE_UNIT/xmax)/(20 + dist) +
		lut_cos(17 * y * ANGLE_UNIT/ymax)/(20 + dist);
	      break;
	      
	    case 20:	/* 2D Wave Interference */
	      color = lut_cos(17 * x * ANGLE_UNIT / xmax) / 32 +
		lut_cos(17 * y * ANGLE_UNIT / ymax) / 32 + dist + angle;
	      break;
	      
	    case 21:	/* 2D Wave Interference */
	      color = lut_cos(7 * x * ANGLE_UNIT / xmax) / 32 +
		lut_cos(7 * y * ANGLE_UNIT / ymax) / 32 + dist;
	      break;
	      
	    case 22:	/* 2D Wave Interference */
	      color = lut_cos( 7 * x * ANGLE_UNIT / xmax) / 32 +
		lut_cos( 7 * y * ANGLE_UNIT / ymax) / 32 +
		lut_cos(11 * x * ANGLE_UNIT / xmax) / 32 +
		lut_cos(11 * y * ANGLE_UNIT / ymax) / 32;
	      break;
	      
	    case 23:
	      color = lut_sin (angle * 7) / 32;
	      break;
	      
	    case 24:
	      color = lut_sin (lut_dist(dx + x1, dy + y1) * 2) / 12 +
		lut_sin (lut_dist(dx + x2, dy + y2) * 4) / 12 +
		lut_sin (lut_dist(dx + x3, dy + y3) * 6) / 12 +
		lut_sin (lut_dist(dx + x4, dy + y4) * 8) / 12;
	      break;
	      
	    case 25:
	      color = angle + lut_sin (lut_dist(dx + x1, dy + y1) * 2) / 16 +
		angle + lut_sin (lut_dist(dx + x2, dy + y2) * 4) / 16 +
		lut_sin (lut_dist(dx + x3, dy + y3) * 6) /  8 +
		lut_sin (lut_dist(dx + x4, dy + y4) * 8) /  8;
	      break;
	      
	    case 26:
	      color = angle + lut_sin (lut_dist(dx + x1, dy + y1) * 2) / 12 +
		angle + lut_sin (lut_dist(dx + x2, dy + y2) * 4) / 12 +
		angle + lut_sin (lut_dist(dx + x3, dy + y3) * 6) / 12 +
		angle + lut_sin (lut_dist(dx + x4, dy + y4) * 8) / 12;
	      break;
	      
	    case 27:
	      color = lut_sin (lut_dist(dx + x1, dy + y1) * 2) / 32 +
		lut_sin (lut_dist(dx + x2, dy + y2) * 4) / 32 +
		lut_sin (lut_dist(dx + x3, dy + y3) * 6) / 32 +
		lut_sin (lut_dist(dx + x4, dy + y4) * 8) / 32;
	      break;

	    case 28:	/* Random Curtain of Rain (in strong wind) */
	      if (y == 0 || x == 0)
		color = RANDOM (16);
	      else
		color = (  *(buf_graf + (xmax *  y   ) + (x-1))
			   + *(buf_graf + (xmax * (y-1)) +    x)) / 2
                  + RANDOM (16) - 8;
	      break;
	      
	    case 29:
	      if (y == 0 || x == 0)
		color = RANDOM (1024);
	      else
		color = dist/6 + (*(buf_graf + (xmax * y    ) + (x-1))
				  +  *(buf_graf + (xmax * (y-1)) +    x)) / 2
		+ RANDOM (16) - 8;
	      break;
	      
	    case 30:
	      color = lut_sin (lut_dist(dx,     dy - 20) * 4) / 32 ^
		lut_sin (lut_dist(dx + 20,dy + 20) * 4) / 32 ^
		lut_sin (lut_dist(dx - 20,dy + 20) * 4) / 32;
	      break;
	      
	    case 31:
	      color = (angle % (ANGLE_UNIT/4)) ^ dist;
	      break;
	      
	    case 32:
	      color = dy ^ dx;
	      break;
	      
	    case 33:	/* Variation on Rain */
	      if (y == 0 || x == 0)
		color = RANDOM (16);
	      else
		color = (  *(buf_graf + (xmax *  y   ) + (x-1))
			   + *(buf_graf + (xmax * (y-1)) +  x   )  ) / 2;
	      
	      color += RANDOM (2) - 1;
	      
	      if (color < 64)
		color += RANDOM (16) - 8;
	      else
						color = color;
	      break; 
	      
	    case 34:	/* Variation on Rain */
	      if (y == 0 || x == 0)
		color = RANDOM (16);
	      else
		color = (  *(buf_graf + (xmax *  y   ) + (x-1))
			   + *(buf_graf + (xmax * (y-1)) +  x   )  ) / 2;
	      
	      if (color < 100)
		color += RANDOM (16) - 8;
	      break;
	      
	    case 35:
	      color = angle + lut_sin(dist * 8)/32;
	      dx = x - xcenter;
	      dy = (y - ycenter)*2;
	      dist  = lut_dist (dx, dy);
          angle = lut_angle (dx, dy);
          color = (color + angle + lut_sin(dist * 8)/32) / 2;
	  break;
	  
	    case 36:
	      color = angle + lut_sin (dist * 10) / 16 +
		lut_cos (x * ANGLE_UNIT / xmax * 2) / 8 +
		lut_cos (y * ANGLE_UNIT / ymax * 2) / 8;
	      dx = x - xcenter;
	      dy = (y - ycenter)*2;
	      dist  = lut_dist (dx, dy);
	      angle = lut_angle (dx, dy);
	      color = (color + angle + lut_sin(dist * 8)/32) / 2;
	      break;
	      
	    case 37:
	      color = angle + lut_sin (dist * 10) / 16 +
		lut_cos (x * ANGLE_UNIT / xmax * 2) / 8 +
		lut_cos (y * ANGLE_UNIT / ymax * 2) / 8;
	      dx = x - xcenter;
	      dy = (y - ycenter)*2;
	      dist  = lut_dist (dx, dy);
          angle = lut_angle (dx, dy);
          color = (color + angle + lut_sin (dist * 10) / 16 +
		   lut_cos (x * ANGLE_UNIT / xmax * 2) / 8 +
		   lut_cos (y * ANGLE_UNIT / ymax * 2) / 8)  /  2;
	  break;
	  
	    case 38:
	      if (dy%2)
		{
		  dy *= 2;
		  dist  = lut_dist (dx, dy);
		  angle = lut_angle (dx, dy);
		}
	      color = angle + lut_sin(dist * 8)/32;
	      break;
	      
	    case 39:
	      color = (angle % (ANGLE_UNIT/4)) ^ dist;
	      dx = x - xcenter;
	      dy = (y - ycenter)*2;
	      dist = lut_dist (dx, dy);
	      angle = lut_angle (dx, dy);
	      color = (color +  ((angle % (ANGLE_UNIT/4)) ^ dist)) / 2;
	      break;
	      
	    case 40:
	      color = dy ^ dx;
	      dx = x - xcenter;
	      dy = (y - ycenter)*2;
	      color = (color +  (dy ^ dx)) / 2;
	      break;

	    default:
	      color = RANDOM (colormax - 1) + 1;
	      break;
	    }
	  
	  /* Fit color value into the palette range using modulo.  It seems 
             that the Turbo-C MOD function does not behave the way I expect.
             It gives negative values for the MOD of a negative number.
             I expect MOD to function as it does on my HP-28S.
	   */

	  color = color % (colormax-1);
	  
	  if (color < 0)
	    color += (colormax - 1);
	  
	  ++color;
          /* color 0 is never used, so all colors are from 1 through 255 */
	  
	  *(buf_graf + (xmax * y) + x) = (UCHAR)color;
		//		printf("y %i vs ymax %y\n", y, ymax);
          /* Store the color in the buffer */
	}
      /* end for (y = 0; y < ymax; ++y)	*/
    }
  /* end for (x = 0; x < xmax; ++x)	*/
  
#if 0	/* For diagnosis, put palette display line at top of new image	*/
  for (x = 0; x < xmax; ++x)
    {
      color = (x <= 255) ? x : 0;
      
      for (y = 0; y < 3; ++y)
	*(buf_graf + (xmax * y) + x) = (UCHAR)color;
    }
#endif
  
  return (0);
}
